/*

MKJSON dient 2 Zwecken:
	1. auch die Basistypen sind MKJSON-Objekte
	2. die Funktionen by... fangen evtl. auftretende Exceptions ab und geben sie als Teil
	 des Resultats zurueck.

Die 4 Memberfunktionen erklaeren sich selbst.

*/

var MKJSON = function(){
	var toString = function(obj){
		obj = [obj];
		var str = JSON.stringify(obj);
		str = str.substr(1, str.length - 2);
		return str;
	}
	var toObject = function(str){
		str = '[' + str + ']';
		var obj = JSON.parse(str);
		obj = obj[0];
		return obj;
	}
	var byObject = function(obj){
		var str;
		var exc;
		try{
			str = toString(obj);
		}catch(exc_){
			exc = exc_;
		}	
		var json = {
			str:str,
			obj:obj,
			exc:exc
		};
		return json;
	}
	var byString = function(str){
		var obj;
		var exc;
		try{
			obj = toObject(str);
		}catch(exc_){
			exc = exc_;
		}	
		var json = {
			str:str,
			obj:obj,
			exc:exc
		};
		return json;
	}
	var MKJSON_ = {
		toString: toString,
		toObject: toObject,
		byString: byString,
		byObject: byObject
	};
	return MKJSON_;
}();
