/*

Der iOS RemoteLogger ueberesetzt nach Javascript

loggt JSON Objekte nach 'http://basics.mk-develop.de/dowatchlog/

*/

var Debug   ; if(!Debug   ){alert('Debug is not defined (Debug.js has probably not been loaded).'      );}
var MKJSON  ; if(!MKJSON  ){alert('MKJSON is not defined (MKJSON.js has probably not been loaded).'    );}
var HTTPCall; if(!HTTPCall){alert('HTTPCall is not defined (HTTPCall.js has probably not been loaded).');}

var RemoteLogger = function(){

	var vRemoteLogger = {}

	var cMaxPatLen = 1000
	var cLogURL    = 'http://basics.mk-develop.de/dowatchlog/'
	
	var vIndex
	var vStack
	
	var reset = function(){
		vIndex = -1
		vStack = []
	}

	var filterText = function(aText){
		return encodeURIComponent(aText)
		return aText.replace(/[^a-zA-Z0-9\ \\[\]\{\}\"\,\;\<\>\#\-\/]/g, "")
	}	

	var logPat = function(aText, aCB){
		var vText   = filterText(aText)
		var vParams = '_=' + vText
		HTTPCall.httpCall(false, cLogURL, vParams, aCB)
	}

	var next = function(){
		vIndex += 1
		if(vIndex < vStack.length){
			logPat(vStack[vIndex], next)
		}else{
			reset()
		}
	}

	var add = function(aLog){
		var vEmpt = !vStack.length
		vStack.push(aLog)
		if(vEmpt){
			next()	
		}
	}

	var logStr = function(aStr){
		var vLen = aStr.length
		for(var vInd = 0; vInd < vLen; vInd += cMaxPatLen){
			var vSub = aStr.substr(vInd, cMaxPatLen)
			add(vSub)
		}
	}

	var logObj = function(aObj){
		var vStr = MKJSON.toString(aObj) + ','
		logStr(vStr)
	}

	var logStackTrace = function(){
		var vStackTraceArr = Debug.getStackTrace()
		var vStackTraceMap = {}
		vStackTraceMap['StackTrace'] = vStackTraceArr
		logObj(vStackTraceMap)
	}

	vRemoteLogger.log           = logObj
	vRemoteLogger.logStackTrace = logStackTrace
	
	reset()
	
	return vRemoteLogger

}();
