/*

Sammlung aller "losen" , d.h. an kein Klassen Objekt gebundenen Funktionen

*/

// Debug

var debug = function(aArg){
	alert('DEBUG ' + aArg)
	var vLogArr = []
	
	var vCount    = Count.count()
	var vSettings = {'SETTINGS':TelekomSettings.getSettings()}
	
	vLogArr.push('DEBUG'  )
	vLogArr.push(aArg     )
	vLogArr.push(vCount   )
	vLogArr.push(vSettings)
	vLogArr.push('/DEBUG' )

	RemoteLogger.log(vLogArr)

	alert('/DEBUG')
}

// Locale

var setLocale = function(aLocale){
	TelekomLocale.setLocale(aLocale)
	TelekomSettings.clear()
	refreshOPML(defaultOnFinished)
}

/*
	Trivialer Wrapper um die die jQuery trigger Funktion. Wird benutzt zum Debuggen 
	(loggen, Haltepunkte setzen, mittlere Zeile auskommentieren zum Deaktivieren, ...)
*/
var triggerCreate = function(jqr){
	jqr.trigger('create');
}

/*
Togglen der Anzeige, Abstraktion vom Style
*/
var display = function(jqr, isDisplayed){
	jqr.css('display', isDisplayed ? 'block' : 'none');
}

/*
 Entfernt alle Tags aus HTML und macht so Text daraus.
 */
var removeTags = function(html){
	var text = []   ;
	var inTag  = false;
	$.each(html, function(indexOfChr, chr){
		   var isBra = chr == '<';
		   var isCat = chr == '>';
		   var isNrm = !isBra && !isCat;
		   if(inTag){
		   if(isCat){inTag = false;}
		   }else{
		   if(isBra){inTag = true;    }
		   if(isNrm){text.push(chr);}		
		   } 
		   });
	text = text.join('');
	return text;
}

/*
 Liefert ein String, der die Namen aller Komponenten des Objekts enthaelt.
 Sinnvoll wenn man raten muss.
 */

var inStr = function(par){
	var aus = '';
	for (var chi in par){
		aus += ' ';
		aus += chi;
	}
	return aus;
}

var alertHTML = function(){
	alert(' ' + '<html>' + $('#htmlID').html() + '</html>' + ' ');
}
/*
 Loggt via PhoneGapPlugin in die Console. Funktioniert im Gegensatz
 zu console.log IMMER.
 */

var log = function(entry){
	try{console         .log (entry);}catch(e){}
	try{$('#debugDivID').html(entry);}catch(e){}
}

var cLog = function(entry){
	try{console.log('cLog: ' + entry);}catch(e){}
}

var cLogStackTrace = function(){
    cLog('StackTrace');
    var vError = new Error();
    var vStackTrace = vError.stack;
    cLog(vStackTrace);
    cLog('/StackTrace');
}

/*
 Loggt das komplette HTML in die Console.  
 */

var logHTML = function(){
	var html = '<html>' + $('#htmlID').html() + '</html>';
	log(html);
}

/*
 Loggt das komplette JSON in die Console.  
 */

var logJSON = function(){
	var logJSON_ = function(json){
		log(MKJSON.toString(json));
	}
	TelekomGlobalJSONCache.getAsync(logJSON_, false);
}

//function onLoad(){document.addEventListener("deviceready", onOldDeviceReady_);}

var onOldDeviceReady_ = function(){
//	initPGPluginPush();
	onOldDeviceReady();
}

var onOldDeviceReady = function(){

cLog('onOldDeviceReady');
//	alert('onOldDeviceReady');


/*
	var onScrollStart = function(){}
	var onScrollStop  = function(){}
 

	$(window).bind('scrollstart', onScrollStart);
	$(window).bind('scrollstop' , onScrollStop );

*/

	var eventType = 'touchstart';
	/* Wenns im Browser laufen soll
	var eventType = 'click';
	*/
							
	$('#leftHeaderButtonID' ).bind(eventType, TelekomHeaderButton.onLeft );
	$('#rightHeaderButtonID').bind(eventType, TelekomHeaderButton.onRight);

	TelekomActivityIndicator.inc();
	showOPML(false, defaultOnFinished);

// Wenn man zum Testen einen Artikel mit einer bestimmten ArtikelID ansehen will
//						showArticleWithID('0914CE12-792A-4942-95E3-0898A8E2A268');

// Wenn man zum Testen die SettingsSeite ansehen will
//						TelekomActivityIndicator.inc();
//						showSettings((false, defaultOnFinished);


// Wenn man zum Testen den ersten Artikel ansehen will
// Achtung zurueck button tuts dann nicht
// weil die ID des zug. OPML-ListenLIs nicht bekannt ist
//						TelekomActivityIndicator.inc();
//						showArticle(0, 0, ,0 defaultOnFinished);


cLog('/onOldDeviceReady');



}

// Typischerweise laufen komplexere Prozesse asynchron ab und während des Ablaufs wird der
// ActivityIndicator angezeigt. Beim Ende wird ein Callback aufgerufen. Typisherweise tut
// der nichts weiter als nur den ActivityIndicator wieder anzuhalten.
var defaultOnFinished = function(){
	TelekomActivityIndicator.dec();
}	

// Wenn man die OPML Seite anzeigen und vorher definitv neu laden will
var refreshOPML = function(onFinished){
	showOPML(true, onFinished);
}	
	
// Wenn man die OPML Seite anzeigen will
var showOPML = function(){
	var showOPML_ = [];
	showOPML_.push(function(forceReload, onFinished){

	
		// Wenn man den kompletten JSON Baum bekommt, wird das HTML in diesem callBack
		// erstellt. Normalerweise kommt der aus dem Cache.
	
		var onAllJSON = function(allJSON){
			var outlineCollapsibles = [];
			var body     = allJSON.json;
			var outlines = body.outlines;
			var settings = body.settings;
			$.each(outlines, function(indexOfOutline, outline){
				var shouldBeDisplayed = settings[outline.id].shouldBeDisplayed;
				if(shouldBeDisplayed){			
					var outlineLis   = [];
					var articles     = outline.channel.articles;
					$.each(articles, function(indexOfArticle, article){
						var articleEnclosure = article.enclosure2.small;
						var outlineLi;
						if(articleEnclosure){
							var encURL = TelekomCrypto.getImgURLString(articleEnclosure.url);
							outlineLi = Snippets.allLiE(article.liID, article.outlineIndex, article.index, encURL, article.title, article.parsedDescription);
						}else{
							outlineLi = Snippets.allLi(article.liID, article.outlineIndex, article.index, article.title, article.parsedDescription);
						}	
						outlineLis.push(outlineLi);
					});
					
					if(!outlineLis.length){
						outlineLis.push(Snippets.noContentsLi());
					}
					
					outlineLis = outlineLis.join('');
					var outlineCollapsible;
					if(indexOfOutline){
						if(outline.isLast){
							outlineCollapsible = Snippets.collapsibleInternal(outline.collapsibleID, outline.title, outlineLis);
						}else{
							outlineCollapsible = Snippets.collapsible(outline.collapsibleID, outline.title, outlineLis);
						}	
					}else{
						outlineCollapsible = Snippets.collapsibleFirst(outline.collapsibleID, outline.title, outlineLis);
					}	
					outlineCollapsibles.push(outlineCollapsible);
				}
			});
			outlineCollapsibles = outlineCollapsibles.join('');
			showHTMLPerformantly(outlineCollapsibles, ['opmlDivID', 'articleDivID', 'settingsDivID', 'errorDivID'], 'opmlDivID', forceReload);
			$.each(outlines, function(indexOfOutline, outline){
				var outlineCollapsible = $('#' + outline.collapsibleID);
				outlineCollapsible.trigger(outline.isCollapsibleOpen ? 'expand': 'collapse');
				var onCollapseExpand = function(collapseExpand){
					myScroll.refresh(); 
					outline.isCollapsibleOpen = collapseExpand;
					if(collapseExpand){
						rafaScrollOnExpand();
					}
				}
				outlineCollapsible.bind('expand'  , function(){onCollapseExpand(true );});
				outlineCollapsible.bind('collapse', function(){onCollapseExpand(false);});
			});

			$.each(outlines, function(indexOfOutline, outline){
				var shouldBeDisplayed = settings[outline.id].shouldBeDisplayed;
				if(shouldBeDisplayed){			
					var articles = outline.channel.articles;
					$.each(articles, function(indexOfArticle, article){
						var articleLiID         = article.liID        ;
						var articleOutlineIndex = article.outlineIndex;
						var articleIndex        = article.index       ;
					});
				}	
			});
			
			TelekomHeaderButton.setOnLeft (function(){refreshOPML (       defaultOnFinished);});
			TelekomHeaderButton.setOnRight(function(){showSettings(false, defaultOnFinished);});
			TelekomHeaderButton.setLeftReloadBack(false);
			TelekomHeaderButton.displayRight(true);

			triggerCreate($('#headerTitleID').html('telekom.com'));
			onFinished();
		} // onAllJSON
		TelekomGlobalJSONCache.getAsync(onAllJSON, forceReload);
	});
	return showOPML_[0];
}();

// scrollTop beim Oeffnen eines nicht oben ligenden Collapisbles
var rafaScrollOnExpand = function(){
	var numberOfScheduledSteps = 0;
	var rafaScrollOnExpand_    = function(){
		var fromY         = $(window).scrollTop();
		var toY           = fromY;
		var fromT         =     0;
		var toT           =     0;
		var totalDeltaY   =   100;
		var totalDeltaT   =   500;
		var numberOfSteps =    30;
		var deltaY        = totalDeltaY / numberOfSteps;
		var deltaT        = totalDeltaT / numberOfSteps;
		if(!numberOfScheduledSteps && (fromY > totalDeltaY)){
			numberOfScheduledSteps = numberOfSteps;
			for(var indexOfStep = 0; indexOfStep < numberOfSteps; ++indexOfStep){
				toY += deltaY;
				toT += deltaT;
				var getScrollTopDelayed = function(toY){
					var scrollTopDelayed = function(){
						$(window).scrollTop(toY);
						--numberOfScheduledSteps;
					}
					return scrollTopDelayed;
				}		
				JobSchedule.delayJob(toT, getScrollTopDelayed(toY));
			}
		}
	}
	return rafaScrollOnExpand_;
}();

// Wenn man den Artikel mit einer bestimmten ID sehen will
// Wird von der PushNotification aufgerufen 
var showArticleWithID = function(articleID_){
	var onAllJSON = function(allJSON){
		var outlines = allJSON.json.outlines;
		$.each(outlines, function(indexOfOutline, outline){
			var articles = outline.channel.articles;
			$.each(articles, function(indexOfArticle, article){
				var articleID   = article.id  ;
				var articleLiID = article.liID;
				if(articleID == articleID_){
					TelekomActivityIndicator.inc();
					showArticle(indexOfOutline, indexOfArticle, articleLiID, defaultOnFinished);
				}
			});
		});
		defaultOnFinished();
	}
	TelekomActivityIndicator.inc();
	TelekomGlobalJSONCache.getAsync(onAllJSON);
}

// Wenn man den Artikel in einer bestimmten Position (FeedNr, ArtikelNr) sehen will. Zum 
// Rucksprung braucht man die LiID das ist die ID des Listenelements unter dem der Artikel
// angezeigt wird.
var showArticle = function(indexOfOutline, indexOfArticle, articleLiID, onFinished){
	var showOPMLOnFinished = function(){
		defaultOnFinished();
	}

	// Wenn man den kompletten JSON Baum bekommt, wird das HTML in diesem callBack
	// erstellt. Normalerweise kommt der aus dem Cache.
	
	var onAllJSON = function(allJSON){
		var article = allJSON.json.outlines[indexOfOutline].channel.articles[indexOfArticle];
		var articleEnclosure = article.enclosure2.large;
		var articleHTML;
		if(articleEnclosure){
			var encURL = TelekomCrypto.getImgURLString(articleEnclosure.url);
			articleHTML = Snippets.allArticleE(article.topmostID, article.pubDate, article.title, encURL, article.description, indexOfOutline, indexOfArticle, article.link);
		}else{
			articleHTML = Snippets.allArticle(article.topmostID, article.pubDate, article.title, article.description, indexOfOutline, indexOfArticle, article.link);
		}	
		
		showHTMLPerformantly(articleHTML, ['opmlDivID', 'articleDivID', 'settingsDivID', 'errorDivID'], 'articleDivID', true);
		TelekomHeaderButton.setOnLeft (function(){showOPML    (false, showOPMLOnFinished);});
		TelekomHeaderButton.setOnRight(function(){showSettings(false, defaultOnFinished);});

		TelekomHeaderButton.displayRight(true);
		TelekomHeaderButton.setLeftReloadBack(true);

		triggerCreate($('#headerTitleID').html(article.parsedOutlineTitle));
		onFinished();
		log('article.id ' + article.id);
	}
	TelekomGlobalJSONCache.getAsync(onAllJSON);
}

// Wenn man den Artikel in einer bestimmten Position (FeedNr, ArtikelNr) sehen will und 
// keinen Callbask uebergeben kann. Zum Rucksprung braucht man die LiID das ist die ID 
// des Listenelements unter dem der Artikel angezeigt wird.
var showArticleWithOnFinished = function(indexOfOutline, indexOfArticle, articleLiID){
	var onFinished = function(){
		defaultOnFinished();
	}
	TelekomActivityIndicator.inc();
	showArticle(indexOfOutline, indexOfArticle, articleLiID, onFinished);
}

// Wenn man die Settings-Seite sehen will
var showSettings = function(forceReload, onFinished){

	// Wenn man den kompletten JSON Baum bekommt, wird das HTML in diesem callBack
	// erstellt. Normalerweise kommt der aus dem Cache.
	
	var onAllJSON = function(allJSON){
	
		var vDebug = true ;
		var vDebug = false;

		var vButtonDebug = vDebug ?  Snippets.buttonDebug() : '';   

		var vLocale = TelekomLocale.getLocale()
		
		var                 vButtonLocale = vLocale
		if(vLocale == 'DE'){vButtonLocale = Snippets.buttonLocaleDE()}
		if(vLocale == 'EN'){vButtonLocale = Snippets.buttonLocaleEN()}

		var                 vPushNotification = vLocale
		if(vLocale == 'DE'){vPushNotification = Snippets.pushNotificationDE()}
		if(vLocale == 'EN'){vPushNotification = Snippets.pushNotificationEN()}

		var                 vChannelOnOff = vLocale
		if(vLocale == 'DE'){vChannelOnOff = Snippets.channelOnOffDE()}		
		if(vLocale == 'EN'){vChannelOnOff = Snippets.channelOnOffEN()}	

		var outlineSettings = [];
		var body     = allJSON.json;
		var outlines = body.outlines;
		var settings = body.settings;

		var vBodyImpr      = body.impr
		var vBodyImprTitle = vBodyImpr.title
		var vBodyImprDescr = vBodyImpr.descr

		var vImpressum    = Snippets.impressum(vBodyImprTitle,vBodyImprDescr)    

		$.each(outlines, function(indexOfOutline, outline){
			var outlineSetting;
			if(indexOfOutline){outlineSetting = Snippets.settingLocalized     (outline.title, outline.shouldReceivePushCheckBoxID, vPushNotification, outline.shouldBeDisplayedCheckBoxID, vChannelOnOff);}
			else              {outlineSetting = Snippets.settingFirstLocalized(outline.title, outline.shouldReceivePushCheckBoxID, vPushNotification                                                    );}
			outlineSettings.push(outlineSetting);
		});

		outlineSettings = outlineSettings.join('');
		outlineSettings = Snippets.settingsLocalized(vButtonDebug, vButtonLocale, outlineSettings, vImpressum);
		
		console.log(outlineSettings);
		
		showHTMLPerformantly(outlineSettings, ['opmlDivID', 'articleDivID', 'settingsDivID', 'errorDivID'], 'settingsDivID', true);
		TelekomHeaderButton.setOnLeft (function(){showOPML    (false, defaultOnFinished);});
		TelekomHeaderButton.setOnRight(function(){showSettings(false, defaultOnFinished);});
		$.each(outlines, function(indexOfOutline, outline){
			var outlineSettings = settings[outline.id];
			var shouldReceivePushCheckBox = getCheckBox(outline.shouldReceivePushCheckBoxID);
			var shouldBeDisplayedCheckBox = getCheckBox(outline.shouldBeDisplayedCheckBoxID);
			shouldReceivePushCheckBox.setIsChecked(outlineSettings.shouldReceivePush);
			shouldBeDisplayedCheckBox.setIsChecked(outlineSettings.shouldBeDisplayed);
			var setShouldReceivePush = function(outlineID, shouldReceivePush){
				if(shouldReceivePush){
					setShouldBeDisplayed(outlineID, true);
					shouldBeDisplayedCheckBox.setIsChecked(true);
				}
				TelekomSettings.setShouldReceivePush(outlineID, shouldReceivePush);
				TelekomHeaderButton.setOnLeft(function(){refreshOPML(defaultOnFinished);});
			}
			var setShouldBeDisplayed = function(outlineID, shouldBeDisplayed){
				if(!shouldBeDisplayed){
					setShouldReceivePush(outlineID, false);
					shouldReceivePushCheckBox.setIsChecked(false);
				}
				TelekomSettings.setShouldBeDisplayed(outlineID, shouldBeDisplayed);
				TelekomHeaderButton.setOnLeft(function(){refreshOPML(defaultOnFinished);});
			}
			shouldReceivePushCheckBox.addListener('change', function(checkBox){setShouldReceivePush(outline.id, checkBox.getIsChecked())});
			shouldBeDisplayedCheckBox.addListener('change', function(checkBox){setShouldBeDisplayed(outline.id, checkBox.getIsChecked())});
		});

		TelekomHeaderButton.displayRight(false);
		TelekomHeaderButton.setLeftReloadBack(true);
		triggerCreate($('#headerTitleID').html('telekom.com'));
		onFinished();
	}
	TelekomGlobalJSONCache.getAsync(onAllJSON, forceReload);
}	

var showErrorPage = function(){

cLogStackTrace();

	showHTMLPerformantly(Snippets.error(), ['opmlDivID', 'articleDivID', 'settingsDivID', 'errorDivID'], 'errorDivID', false);
	TelekomHeaderButton.setOnLeft(function(){refreshOPML(defaultOnFinished);});
	TelekomHeaderButton.displayRight(false);
	TelekomHeaderButton.setLeftReloadBack(true);
	triggerCreate($('#headerTitleID').html('telekom.com'));
}

// Erzeugt ein CheckBox Objekt
// JQM laesst Methoden vermissen wie
// getIsChecked und setIsChecked
var getCheckBox = function(checkBoxObjID){
	var getCheckBox_ = {};
	var getID = function(){
		return checkBoxObjID;
	}	
	var getJQR = function(){
		return $('#' + getID());
	}	
	var getIsChecked = function(){
		return !!getJQR().attr('checked');
	}
	var setIsChecked = function(isChecked){
		var jqr = getJQR();
		if(isChecked) jqr.attr      ('checked', 'checked');
		else          jqr.removeAttr('checked'           );
		jqr.checkboxradio("refresh");
	}
	var addListener = function(event, onEvent){
		getJQR().bind(event, function(){
			onEvent(getCheckBox_);
		});
	}	
	getCheckBox_.getID        = getID       ;
	getCheckBox_.getJQR       = getJQR      ;
	getCheckBox_.getIsChecked = getIsChecked;
	getCheckBox_.setIsChecked = setIsChecked;
	getCheckBox_.addListener  = addListener ;
	return getCheckBox_;
}

// die JQM Funktion mit etwas Intelligenz drum herum
// Parameter:
// html      - das einzusetzende HTML
// divIDs    - die IDs aller contentDivs
// showDivID - dasjenige aller contentDivs, in das das HTML soll
// force     - ob bereits vorhandenes HTML ueberschrieben werden soll 
var showHTMLPerformantly = function(html, divIDs, showDivID, force){

	html = VideoTagParser.parse(html);

	var showDiv  = $('#' + showDivID);
	var platform = getPlatform();
	
	/*
		Bug 3312: 
		
		An obscure issue exists in iOS5 and some Android platforms where form controls 
		placed inside fixed-positioned containers can lose their hit area when the window 
		is programatically scrolled (using window.scrollTo for example). This is not an 
		issue specific to jQuery Mobile, but because of it, we recommend not 
		programatically scrolling a document when using form controls inside jQuery 
		Mobile fixed toolbars. This ticket from the Device Bugs project tracker explains 
		this problem in more detail.

		https://github.com/scottjehl/Device-Bugs/issues/1
		
		Folgende Lsg: Div unten an das HTML hängen mit einer ID und einem nbsp drin.
		Die Sichtbarkeit dieses Objekts an und verzoegert wieder aus schalten.
		
	*/

	if(platform == 'iPhone'){
		var bug3312DivID = showDivID + 'Bug3312DivID';
		var bug3312HTML  = '<div id="' + bug3312DivID + '">&nbsp;</div>';
		html += bug3312HTML;
	}

	var vDoChange = force || !showDiv.html().length
	if(vDoChange){
		showDiv.html(html);
		triggerCreate(showDiv);
	}
	$.each(divIDs, function(indexOfDivID, divID){
		var div = $('#' + divID);
		display(div, divID == showDivID);
	});
	$.mobile.silentScroll(0);
	myScroll.refresh();
	
	if(platform == 'iPhone'){
		var displayBug3312Div = function(isDisplayed){
			var bug3312Div = $('#' + bug3312DivID);
			display(bug3312Div, isDisplayed);
		}	
		displayBug3312Div(true);
		JobSchedule.delayJob(700, function(){
			displayBug3312Div(false);
		});
	}

}

// registriert Tags bei UrbanAirship
var registerTags = function(tags){
    push.setTags(tags, function(){});
}

var flashPressed = function(objID){
	var obj = $('#' + objID);
	obj.addClass('pressed');
	JobSchedule.delayJob(700, function(){
		obj.removeClass('pressed');
	});
}

// Verwaltet die beiden Buttons: Aussehen, Funktionalitaet und Responsibilitaet
var TelekomHeaderButton = function(){
	var quasiOnLeft  = [function(){alert('TelekomHeaderButton::onLeft' ); TelekomActivityIndicator.dec();}];
	var quasiOnRight = [function(){alert('TelekomHeaderButton::onRight'); TelekomActivityIndicator.dec();}];
	var onLeftRight = function(divID, quasiFkt){
		flashPressed(divID);
		TelekomActivityIndicator.inc(); 
		quasiFkt[0]();
	}	

	var onLeft  = function(){onLeftRight('leftHeaderButtonID' , quasiOnLeft );}
	var onRight = function(){onLeftRight('rightHeaderButtonID', quasiOnRight);}
	
	var setOnLeft  = function(onLeft_ ){quasiOnLeft [0] = onLeft_ ;}
	var setOnRight = function(onRight_){quasiOnRight[0] = onRight_;}
	
	var setLeftReloadBack = function(reloadBack){
		var leftButton = $('#leftHeaderButtonID');
		leftButton.removeClass('reload');
		leftButton.removeClass('back'  );
		leftButton.addClass(reloadBack ? 'back' : 'reload');
		triggerCreate(leftButton);
	}
	var displayRight = function(isDisplayed){
		var rightButton = $('#rightHeaderButtonID');
		display(rightButton, isDisplayed);
	}
	var TelekomHeaderButton_ = {
		onLeft    :onLeft    ,
		onRight   :onRight   ,
		setOnLeft :setOnLeft ,
		setOnRight:setOnRight,
		setLeftReloadBack:setLeftReloadBack,
		displayRight:displayRight
	}
	return TelekomHeaderButton_;
}();

/*

Wir haben die Hoffnung noch nicht ganz aufgegeben, mit iScroll4 den Header zu fixieren.
Dabei wuerde das native Scrollen deaktiviert und dann der Contentbereich mit iScroll (JS)
gescrollt. Bisher fuehrt das aber zu inakzetptaben Scorllverhalten (ruckelt bei 
komplexerem HTML).

*/

var myScroll = {
	refresh:function(){}
}
