/*
 
 KnowledgeBase-Funktion. Doku siehe dort.
 
 */


var Count; if(!Count){alert('Count is not defined (Count.js has probably not been loaded).');}
var TimeStamp; if(!TimeStamp){alert('TimeStamp is not defined (TimeStamp.js has probably not been loaded).');}

var JobSchedule = function(){
	var jobSchedule = {};
	var scheduleJobRelativeWithMillis = function(millis, func){
		var jobID = Count.count();
		jobSchedule[jobID] = func;
		setTimeout('JobSchedule.executeJob(' + jobID + ');', millis);
		return jobID;
	}
	var scheduleJobRelativeWithSeconds = function(seconds, func){return scheduleJobRelativeWithMillis(seconds * 1000.0                   , func);}
	var scheduleJobAbsoluteWithMillis  = function(millis , func){return scheduleJobRelativeWithMillis(millis  - TimeSTamp.timeStamp(    ), func);}
	var scheduleJobAbsoluteWithDate    = function(date   , func){return scheduleJobAbsoluteWithMillis(          TimeSTamp.timeStamp(date), func);}
	var cancelJob  = function(jobID){delete jobSchedule[jobID];}
	var executeJob = function(jobID){
		var job = jobSchedule[jobID];
		if(job){
			cancelJob(jobID);
			job();
		}
	}
	var delayJob = function(millis, job){
		scheduleJobRelativeWithMillis(millis, job);
	}
	var repeatJob = function(millis, job){
		var _job = function(){
			delayJob(millis, _job);
			job();
		}
		_job();
	};
	var _JobSchedule = {
		scheduleJobRelativeWithMillis :scheduleJobRelativeWithMillis ,
		scheduleJobRelativeWithSeconds:scheduleJobRelativeWithSeconds,
		scheduleJobAbsoluteWithMillis :scheduleJobAbsoluteWithMillis ,
		scheduleJobAbsoluteWithDate   :scheduleJobAbsoluteWithDate   ,
		delayJob                      :delayJob                      ,
		repeatJob                     :repeatJob                     ,
		cancelJob                     :cancelJob                     ,
		executeJob                    :executeJob 
	}	
	return _JobSchedule;
}();