/*

MKLog: die inzwischen auch in JAVA und ObjC verfuegbare Logger Klasse uebersetzt nach JS

*/

var MKLog = function(){

	var vLogTag = 'MKLog';

	var vAlrt = function(aMsg){alert      (aMsg);}
	var vCLog = function(aMsg){console.log(aMsg);}
	
	var vQuasiLog;
	
	var setAlrt = function(){vQuasiLog = vAlrt;}
	var setClog = function(){vQuasiLog = vCLog;}
	
	var getIsAlrt = function(){return vQuasiLog == vAlrt;}
	var getIsClog = function(){return vQuasiLog == vCLog;}

	setClog();
		
	var getStackTrace = function(){
		var vError = new Error();
		var vStack = vError.stack;
		return vStack;
	}

	var log = function(aMsg){
		var vMsg = vLogTag + "|" + aMsg;
		vQuasiLog(vMsg);
	}	

	var logJSON = function(aObject){
		var         vLogString
		try        {vLogString = MKJSON.toString(aObject)}
		catch(aExc){vLogString = aExc.message            }
		log(vLogString)
	}
	
	var logKeys = function(aMap, aOwnKeysOnly){
		var vMsgMap = {}
		for(var vKey in aMap) {
			if (!aOwnKeysOnly || aMap.hasOwnProperty(vKey)){
				var vVal = aMap[vKey]
				vKey = '' + vKey
				vVal = '' + vVal
				vMsgMap[vKey] = vVal
			}
		}
		logJSON(vMsgMap)
	}	

	var logStackTrace = function(){
		log('StackTrace');
		vStack = getStackTrace();
		log(vStack);
		log('/StackTrace');
	}

	var MKLog_ = {};

	MKLog_.setAlrt = setAlrt;
	MKLog_.setClog = setClog;
	
	MKLog_.getIsAlrt = getIsAlrt;
	MKLog_.getIsClog = getIsClog;
	
	MKLog_.getStackTrace = getStackTrace;
	
	MKLog_.log           = log          ;
	MKLog_.logKeys       = logKeys      ;
	MKLog_.logJSON       = logJSON      ;
	MKLog_.logStackTrace = logStackTrace;
	
	return MKLog_;

}();


